<?php
/*------------------------------------------------------------------------
# com_zhyandexmap - Zh YandexMap
# ------------------------------------------------------------------------
# author    Dmitry Zhuk
# copyright Copyright (C) 2011 zhuk.cc. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or later
# Websites: http://zhuk.cc
# Technical Support:  Development Page - http://zhuk.cc/?page_id=504
-------------------------------------------------------------------------*/
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

$mapVersion = "1.1";

$apikey = $this->mapapikey;

$compatiblemodersf = $this->mapcompatiblemodersf;
if ($compatiblemodersf == "")
{
  $compatiblemodersf = 0;
}


$document	= JFactory::getDocument();

$scriptlink	= 'http://api-maps.yandex.ru/'.$mapVersion.'/index.xml?key='. $apikey ;
$loadmodules	='';

$fullWidth = 0;
$fullHeight = 0;

$divmapheader ="";
$divmapfooter ="";


function parse_route_by_markers($markerId)
{
	if ((int)$markerId != 0)
	{
		$dbMrk = JFactory::getDBO();

		$queryMrk = $dbMrk->getQuery(true);
		$queryMrk->select('h.*')
			->from('#__zhyandexmaps_markers as h')
			->where('h.id = '.(int) $markerId);
		$dbMrk->setQuery($queryMrk);        
		$myMarker = $dbMrk->loadObject();
		
		if (isset($myMarker))
		{
			if ($myMarker->latitude != "" && $myMarker->longitude != "")
			{
				return 'new YMaps.GeoPoint('.$myMarker->longitude.', ' .$myMarker->latitude.')';
			}
			else
			{
				return 'geocode';
			}
		}
		else
		{
			return '';
		}	
	}
}



if ((int)$this->item->useruser != 0)
{
	function get_userinfo_for_marker($userId, $showuser)
	{

		if ($compatiblemodersf == 0)
		{
			$imgpathIcons = JURI::root() .'administrator/components/com_zhyandexmap/assets/icons/';
			$imgpathUtils = JURI::root() .'administrator/components/com_zhyandexmap/assets/utils/';
		}
		else
		{
			$imgpathIcons = JURI::root() .'components/com_zhyandexmap/assets/icons/';
			$imgpathUtils = JURI::root() .'components/com_zhyandexmap/assets/utils/';
		}
	
		
		if ((int)$userId != 0)
		{
			$cur_user_name = '';
			$cur_user_address = '';
			$cur_user_phone = '';
			
			$dbUsr = JFactory::getDBO();
			$queryUsr = $dbUsr->getQuery(true);
			
			$queryUsr->select('p.*, h.name as profile_username')
				->from('#__users as h')
				->leftJoin('#__user_profiles as p ON p.user_id=h.id')
				->where('h.id = '.(int)$userId);

			$dbUsr->setQuery($queryUsr);        
			$myUsr = $dbUsr->loadObjectList();
			
			if (isset($myUsr))
			{
				
				foreach ($myUsr as $key => $currentUsers) 
				{
					$cur_user_name = $currentUsers->profile_username;

					if ($currentUsers->profile_key == 'profile.address1')
					{
						$cur_user_address = $currentUsers->profile_value;
					}
					else if ($currentUsers->profile_key == 'profile.phone')
					{
						$cur_user_phone = $currentUsers->profile_value;
					}
					
					
				}
				
				$cur_scripttext = '';
				
				if (isset($showuser) && ((int)$showuser != 0))
				{
					switch ((int)$showuser) 
					{
						case 1:
							if ($cur_user_name != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.JText::_('COM_ZHYANDEXMAP_MAP_USER_USER_NAME').' '.htmlspecialchars(str_replace('\\', '/', $cur_user_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
							if ($cur_user_address != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.JText::_('COM_ZHYANDEXMAP_MAP_USER_USER_ADDRESS').' '.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $cur_user_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
							}
							if ($cur_user_phone != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.JText::_('COM_ZHYANDEXMAP_MAP_USER_USER_PHONE').' '.htmlspecialchars(str_replace('\\', '/', $cur_user_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
						break;
						case 2:
							if ($cur_user_name != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
							if ($cur_user_address != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser"><img src="'.$imgpathUtils.'address.png" alt="'.JText::_('COM_ZHYANDEXMAP_MAP_USER_USER_ADDRESS').'" />'.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $cur_user_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
							}
							if ($cur_user_phone != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser"><img src="'.$imgpathUtils.'phone.png" alt="'.JText::_('COM_ZHYANDEXMAP_MAP_USER_USER_PHONE').'" />'.htmlspecialchars(str_replace('\\', '/', $cur_user_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
						break;
						case 3:
							if ($cur_user_name != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
							if ($cur_user_address != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $cur_user_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
							}
							if ($cur_user_phone != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
						break;
						default;
							if ($cur_user_name != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
							if ($cur_user_address != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.str_replace('<br /><br />', '<br />',str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $cur_user_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
							}
							if ($cur_user_phone != "") 
							{
								$cur_scripttext .= '\'<p class="placemarkBodyUser">'.htmlspecialchars(str_replace('\\', '/', $cur_user_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
							}
						break;										
					}
				}
				
				return $cur_scripttext;
			}
			else
			{
				return '';
			}	
		}
		else
		{
			return '';
		}	
		
		
	}
}



if (isset($this->item->usermarkers) && (int)$this->item->usermarkers == 1) 
{
	if ($compatiblemodersf == 0)
	{
		$document->addStyleSheet(JURI::root() .'administrator/components/com_zhyandexmap/assets/css/usermarkers.css');
	}
	else
	{
		$document->addStyleSheet(JURI::root() .'components/com_zhyandexmap/assets/css/usermarkers.css');
	}
}

if ($compatiblemodersf == 0)
{
	$directoryIcons = 'administrator/components/com_zhyandexmap/assets/icons/';
	$imgpathIcons = JURI::root() .'administrator/components/com_zhyandexmap/assets/icons/';
	$imgpathUtils = JURI::root() .'administrator/components/com_zhyandexmap/assets/utils/';		
}
else
{
	$directoryIcons = 'components/com_zhyandexmap/assets/icons/';
	$imgpathIcons = JURI::root() .'components/com_zhyandexmap/assets/icons/';
	$imgpathUtils = JURI::root() .'components/com_zhyandexmap/assets/utils/';		
}


if ($this->item->headerhtml != "")
{
        $divmapheader .= '<div id="YMapInfoHeader">'.$this->item->headerhtml;
        if (isset($this->item->headersep) && (int)$this->item->headersep == 1) 
        {
            $divmapheader .= '<hr id="mapHeaderLine">';
        }
        $divmapheader .= '</div>';
}

if (isset($this->item->findcontrol) && (int)$this->item->findcontrol == 1) 
{
	switch ((int)$this->item->findpos) 
	{
		
		case 0:
			$divmapheader .= '<div id="YMapFindAddress">'."\n";
			$divmapheader .= '<form action="#" onsubmit="showAddressByGeocoding(this.findAddressField.value);return false;">'."\n";
			$divmapheader .= '<p>'."\n";
            $divmapheader .= '<input id="findAddressField" type="text" value=""';
			if (isset($this->item->findwidth) && (int)$this->item->findwidth != 0)
			{
				$divmapheader .= ' size="'.(int)$this->item->findwidth.'"';
			}
			$divmapheader .=' />';
			$divmapheader .= '<input id="findAddressButton" type="submit" value="'.JText::_( 'COM_ZHYANDEXMAP_MAP_DOFINDBUTTON' ).'" />'."\n";
			$divmapheader .= '</p>'."\n";
			$divmapheader .= '</form>'."\n";
			$divmapheader .= '</div>'."\n";
		break;
		case 101:
			$divmapheader .= '<div id="YMapFindAddress">'."\n";
			$divmapheader .= '<form action="#" onsubmit="showAddressByGeocoding(this.findAddressField.value);return false;">'."\n";
			$divmapheader .= '<p>'."\n";
            $divmapheader .= '<input id="findAddressField" type="text" value=""';
			if (isset($this->item->findwidth) && (int)$this->item->findwidth != 0)
			{
				$divmapheader .= ' size="'.(int)$this->item->findwidth.'"';
			}
			$divmapheader .=' />';
			$divmapheader .= '<input id="findAddressButton" type="submit" value="'.JText::_( 'COM_ZHYANDEXMAP_MAP_DOFINDBUTTON' ).'" />'."\n";
			$divmapheader .= '</p>'."\n";
			$divmapheader .= '</form>'."\n";
			$divmapheader .= '</div>'."\n";
		break;
		case 102:
			$divmapfooter .= '<div id="YMapFindAddress">'."\n";
			$divmapfooter .= '<form action="#" onsubmit="showAddressByGeocoding(this.findAddressField.value);return false;">'."\n";
			$divmapfooter .= '<p>'."\n";
            $divmapfooter .= '<input id="findAddressField" type="text" value=""';
			if (isset($this->item->findwidth) && (int)$this->item->findwidth != 0)
			{
				$divmapfooter .= ' size="'.(int)$this->item->findwidth.'"';
			}
			$divmapfooter .=' />';
			$divmapfooter .= '<input id="findAddressButton" type="submit" value="'.JText::_( 'COM_ZHYANDEXMAP_MAP_DOFINDBUTTON' ).'" />'."\n";
			$divmapfooter .= '</p>'."\n";
			$divmapfooter .= '</form>'."\n";
			$divmapfooter .= '</div>'."\n";
		break;
		default;
		break;
	}
}


$allowUserMarker = 0;

if (isset($this->item->usermarkers) && (int)$this->item->usermarkers == 1) 
{
    $currentUser = JFactory::getUser();

    if ($currentUser->id == 0)
    {
       $divmapheader .= JText::_( 'COM_ZHYANDEXMAP_MAP_USER_NOTLOGIN' );
       $allowUserMarker = 0;
    }
    else
    {
       $divmapheader .= JText::_( 'COM_ZHYANDEXMAP_MAP_USER_LOGIN' ) .' '. $currentUser->name;
       $allowUserMarker = 1;
    }
    
}

if ($this->item->footerhtml != "")
{
       $divmapfooter .= '<div id="YMapInfoFooter">';
        if (isset($this->item->footersep) && (int)$this->item->footersep == 1) 
        {
            $divmapfooter .= '<hr id="mapFooterLine">';
        }
       $divmapfooter .= $this->item->footerhtml.'</div>';
}

if ((!isset($this->item->width)) || (isset($this->item->width) && (int)$this->item->width < 1)) 
{
	$fullWidth = 1;
}
if ((!isset($this->item->height)) || (isset($this->item->height) && (int)$this->item->height < 1)) 
{
	$fullHeight = 1;
}


if (isset($this->item->markergroupcontrol) && (int)$this->item->markergroupcontrol != 0) 
{
	if ($compatiblemodersf == 0)
	{
		$document->addStyleSheet(JURI::root() .'administrator/components/com_zhyandexmap/assets/css/markergroups.css');
	}
	else
	{
		$document->addStyleSheet(JURI::root() .'components/com_zhyandexmap/assets/css/markergroups.css');
	}
	

	switch ((int)$this->item->markergroupcss) 
	{
		
		case 0:
			$markergroupcssstyle = '-simple';
		break;
		case 1:
			$markergroupcssstyle = '-advanced';
		break;
		case 2:
			$markergroupcssstyle = '-external';
		break;
		default;
			$markergroupcssstyle = '-simple';
		break;
	}

	$divmarkergroup = '<div id="YMapsMenu'.$markergroupcssstyle.'" style="margin:0;padding:0;width=100%">';

        if ($this->item->markergrouptitle != "")
        {
            $divmarkergroup .= '<div id="groupList"><h2 id="groupListHeadTitle" class="groupListHead">'.htmlspecialchars($this->item->markergrouptitle , ENT_QUOTES, 'UTF-8').'</h2></div>';
        }
        
        if ($this->item->markergroupdesc1 != "")
        {
            $divmarkergroup .= '<div id="groupListBodyTopContent" class="groupListBodyTop">'.htmlspecialchars($this->item->markergroupdesc1 , ENT_QUOTES, 'UTF-8').'</div>';
        }

        if (isset($this->item->markergroupsep1) && (int)$this->item->markergroupsep1 == 1) 
        {
            $divmarkergroup .= '<hr id="groupListLineTop">';
        }

		$divmarkergroup .= '<ul id="zhym-menu'.$markergroupcssstyle.'">';
		$divmarkergroup .= '</ul>';

        if (isset($this->item->markergroupsep2) && (int)$this->item->markergroupsep2 == 1) 
        {
            $divmarkergroup .= '<hr id="groupListLineBottom">';
        }
        
        if ($this->item->markergroupdesc2 != "")
        {
            $divmarkergroup .= '<div id="groupListBodyBottomContent" class="groupListBodyBottom">'.htmlspecialchars($this->item->markergroupdesc2 , ENT_QUOTES, 'UTF-8').'</div>';
        }
        

	$divmarkergroup .= '</div>'."\n";
}



if ($fullWidth == 1) 
{
	if ($fullHeight == 1) 
	{
		$divmap = '<div id="YMapsID" style="margin:0;padding:0;width:100%;height:450px"></div>';
	}else{
		$divmap = '<div id="YMapsID" style="margin:0;padding:0;width:100%;height:'.$this->item->height.'px"></div>';
	}		

}
else
{
	if ($fullHeight == 1) 
	{
		$divmap = '<div id="YMapsID" style="margin:0;padding:0;width:'.$this->item->width.'px;height:'.$this->item->width.'px"></div>';			
	}
	else
	{
		$divmap = '<div id="YMapsID" style="margin:0;padding:0;width:'.$this->item->width.'px;height:'.$this->item->height.'px"></div>';			
	}		
}


echo $divmapheader;

if (isset($this->item->markergroupcontrol) && (int)$this->item->markergroupcontrol != 0) 
{
	switch ((int)$this->item->markergroupcontrol) 
	{
		
		case 1:
		       if ($fullWidth == 1) 
		       {
		          echo '<table width="100%">';
		          echo '<tr align="left" >';
		          echo '<td valign="top" width="'.(int)$this->item->markergroupwidth.'%">';
        	          echo $divmarkergroup;
		          echo '</td>';
		          echo '<td>';
		          echo $divmap;
		          echo '</td>';
		          echo '</tr>';
		       }
		       else
		       {
		          echo '<table>';
                          echo '<tr>';
		          echo '<td valign="top">';
        	          echo $divmarkergroup;
		          echo '</td>';
		          echo '<td>';
		          echo $divmap;
		          echo '</td>';
		          echo '</tr>';
                       }
		       echo '</table>';
		break;
		case 2:
		       if ($fullWidth == 1) 
		       {
		          echo '<table width="100%">';
		       }
		       else
		       {
		          echo '<table>';
		       }
		       echo '<tr>';
		       echo '<td valign="top">';
		       echo $divmarkergroup;
		       echo '</td>';
		       echo '</tr>';
		       echo '<tr>';
		       echo '<td>';
		       echo $divmap;
		       echo '</td>';
		       echo '</tr>';
		       echo '</table>';

		break;
		case 3:
		       if ($fullWidth == 1) 
		       {
		          echo '<table width="100%">';
		          echo '<tr>';
		          echo '<td>';
		          echo $divmap;
		          echo '</td>';
		          echo '<td valign="top" width="'.(int)$this->item->markergroupwidth.'%">';
		          echo $divmarkergroup;
		          echo '</td>';
		          echo '</tr>';
		       }
		       else
		       {
		          echo '<table>';
		          echo '<tr>';
		          echo '<td>';
		          echo $divmap;
		          echo '</td>';
		          echo '<td valign="top">';
		          echo $divmarkergroup;
		          echo '</td>';
		          echo '</tr>';
		       }
		       echo '</table>';

		break;
		case 4:
		       if ($fullWidth == 1) 
		       {
		          echo '<table width="100%">';
		       }
		       else
		       {
		          echo '<table>';
		       }
		       echo '<tr>';
		       echo '<td>';
		       echo $divmap;
		       echo '</td>';
		       echo '</tr>';
		       echo '<tr>';
		       echo '<td valign="top">';
		       echo $divmarkergroup;
		       echo '</td>';
		       echo '</tr>';
		       echo '</table>';
		break;
		case 5:
		       echo '<div id="zhym-wrapper">';
		       echo $divmarkergroup;
		       echo $divmap;
		       echo '</div>';
		break;
		case 6:
		       echo '<div id="zhym-wrapper">';
		       echo $divmap;
		       echo $divmarkergroup;
		       echo '</div>';
		break;
		default;
			echo $divmap;
		break;
	}


}
else
{
    echo $divmap;
}

$divmap4route = '<div id="YMapsMainRoutePanel"><div id="YMapsMainRoutePanel_Total"></div></div>';
$divmap4route .= '<div id="YMapsRoutePanel"><div id="YMapsRoutePanel_Description"></div><div id="YMapsRoutePanel_Total"></div></div>';

echo $divmapfooter . $divmap4route;





//Script begin
$scripttext = '<script type="text/javascript" >/*<![CDATA[*/' ."\n";

	$scripttext .= 'var map, mapcenter, geoResult, geoRoute;' ."\n";

	$scripttext .= 'YMaps.jQuery(function () {' ."\n";
		
        $scripttext .= '    map = new YMaps.Map(document.getElementById("YMapsID"));' ."\n";
		$scripttext .= '    mapcenter = new YMaps.GeoPoint( '.$this->item->longitude.', ' .$this->item->latitude.');' ."\n";
        $scripttext .= '    map.setCenter(mapcenter);' ."\n";


	//Double Click Zoom
	if (isset($this->item->doubleclickzoom) && (int)$this->item->doubleclickzoom == 1) 
	{
		$scripttext .= 'map.enableDblClickZoom();' ."\n";
	} 
	else 
	{
		$scripttext .= 'map.disableDblClickZoom();' ."\n";
	}


	//Scroll Wheel Zoom		
	if (isset($this->item->scrollwheelzoom) && (int)$this->item->scrollwheelzoom == 1) 
	{
		$scripttext .= 'map.enableScrollZoom();' ."\n";
	} 
	else 
	{
		$scripttext .= 'map.disableScrollZoom();' ."\n";
	}
		

	//Zoom Control
	if (isset($this->item->zoomcontrol)) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($this->item->zoomcontrolpos)) 
                {
                    switch ($this->item->zoomcontrolpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$this->item->zoomcontrolofsx.','.
                                                        (int)$this->item->zoomcontrolofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }
            
		switch ($this->item->zoomcontrol) 
		{
			case 1:
				$scripttext .= 'map.addControl(new YMaps.Zoom()'.$ctrlPositionFullText.');' ."\n";
			break;
			case 2:
				$scripttext .= 'map.addControl(new YMaps.SmallZoom()'.$ctrlPositionFullText.');' ."\n";
			break;
			default;
				$scripttext .= '' ."\n";
			break;
		}
	}

	//Scale Control
	if (isset($this->item->scalecontrol) && (int)$this->item->scalecontrol == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($this->item->scalecontrolpos)) 
                {
                    switch ($this->item->scalecontrolpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$this->item->scalecontrolofsx.','.
                                                        (int)$this->item->scalecontrolofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }
            
		$scripttext .= 'map.addControl(new YMaps.ScaleLine()'.$ctrlPositionFullText.');' ."\n";
	}
        
	if (isset($this->item->maptypecontrol) && (int)$this->item->maptypecontrol == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($this->item->maptypecontrolpos)) 
                {
                    switch ($this->item->maptypecontrolpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$this->item->maptypecontrolofsx.','.
                                                        (int)$this->item->maptypecontrolofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }
            
		$scripttext .= 'map.addControl(new YMaps.TypeControl()'.$ctrlPositionFullText.');' ."\n";
	}

	if (isset($this->item->pmaptypecontrol) && (int)$this->item->pmaptypecontrol == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($this->item->pmaptypecontrolpos)) 
                {
                    switch ($this->item->pmaptypecontrolpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$this->item->pmaptypecontrolofsx.','.
                                                        (int)$this->item->pmaptypecontrolofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

                $scripttext .= 'map.addControl(new YMaps.TypeControl([YMaps.MapType.PMAP, YMaps.MapType.PHYBRID])'.$ctrlPositionFullText.');' ."\n";
                if (isset($this->item->maptype) && 
                        (((int)$this->item->maptype != 4) || ((int)$this->item->maptype != 5)))
                {
                    if ($loadmodules =='') 
                    {
                            $loadmodules = '&modules=pmap';
                    } 
                    else 
                    {
                            $loadmodules .= '~pmap';
                    }
                }
	}

	// Map type
	if (isset($this->item->maptype)) 
	{
		switch ($this->item->maptype) 
		{
			
			case 1:
				$scripttext .= 'map.setType(YMaps.MapType.MAP);' ."\n";
			break;
			case 2:
				$scripttext .= 'map.setType(YMaps.MapType.SATELLITE);' ."\n";
			break;
			case 3:
				$scripttext .= 'map.setType(YMaps.MapType.HYBRID);' ."\n";
			break;
			case 4:
				$scripttext .= 'map.setType(YMaps.MapType.PMAP);' ."\n";
				if ($loadmodules =='') 
				{
						$loadmodules = '&modules=pmap';
				} 
				else 
				{
						$loadmodules .= '~pmap';
				}
			break;
			case 5:
				$scripttext .= 'map.setType(YMaps.MapType.PHYBRID);' ."\n";
				if ($loadmodules =='') 
				{
						$loadmodules = '&modules=pmap';
				} 
				else 
				{
						$loadmodules .= '~pmap';
				}
			break;
			default;
				$scripttext .= '' ."\n";
			break;
		}
	}

	// Because that we set map type
	if ((int)$this->item->zoom != 200)
	{
		$scripttext .= '    map.setZoom('.(int)$this->item->zoom.');' ."\n";
	}
	else
	{
		$scripttext .= '    map.setZoom(map.getMaxZoom());' ."\n";
	}
	$scripttext .= '    map.setMinZoom('.(int)$this->item->minzoom.');' ."\n";
	if ((int)$this->item->maxzoom != 200)
	{
		$scripttext .= '    map.setMaxZoom('.(int)$this->item->maxzoom.');' ."\n";
	}
	// When changed maptype max zoom level can be other
	$scripttext .= 'YMaps.Events.observe(map, map.Events.ZoomRangeChange, function (map, mEvent) {' ."\n";
	$scripttext .= '  if (map.getZoom() > map.getMaxZoom())' ."\n";
	$scripttext .= '  {	' ."\n";
	$scripttext .= '    map.setZoom(map.getMaxZoom());' ."\n";
	$scripttext .= '  }' ."\n";
	$scripttext .= '});' ."\n";

	//MiniMap
	if (isset($this->item->minimap) && (int)$this->item->minimap == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($this->item->minimappos)) 
                {
                    switch ($this->item->minimappos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$this->item->minimapofsx.','.
                                                        (int)$this->item->minimapofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

            $scripttext .= 'map.addControl(new YMaps.MiniMap()'.$ctrlPositionFullText.');' ."\n";
	}
	
		
	//Toolbar
	if (isset($this->item->toolbar) && (int)$this->item->toolbar == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($this->item->toolbarpos)) 
                {
                    switch ($this->item->toolbarpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$this->item->toolbarofsx.','.
                                                        (int)$this->item->toolbarofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

                $scripttext .= 'map.addControl(new YMaps.ToolBar()'.$ctrlPositionFullText.');' ."\n";
	}
	

	//Search
	if (isset($this->item->search) && (int)$this->item->search == 1) 
	{
                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($this->item->searchpos)) 
                {
                    switch ($this->item->searchpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$this->item->searchofsx.','.
                                                        (int)$this->item->searchofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

                $scripttext .= 'map.addControl(new YMaps.SearchControl()'.$ctrlPositionFullText.');' ."\n";
	}
	

	//Traffic
	if (isset($this->item->traffic) && (int)$this->item->traffic == 1) 
	{
		if ($loadmodules =='') 
		{
			$loadmodules = '&modules=traffic';
		} 
		else 
		{
			$loadmodules .= '~traffic';
		}

                $ctrlPosition = "";
                $ctrlPositionFullText ="";
                
                if (isset($this->item->trafficpos)) 
                {
                    switch ($this->item->trafficpos)
                    {
                        case 1:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_LEFT";
                        break;
                        case 2:
                            $ctrlPosition = "YMaps.ControlPosition.TOP_RIGHT";
                        break;
                        case 3:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_RIGHT";
                        break;
                        case 4:
                            $ctrlPosition = "YMaps.ControlPosition.BOTTOM_LEFT";
                        break;
                        default;
                            $ctrlPosition = "";
                        break;
                    }
                    if ($ctrlPosition != "")
                    {
                        $ctrlPositionFullText = ', new YMaps.ControlPosition('.
                                                    $ctrlPosition.
                                                    ', new YMaps.Point('.
                                                        (int)$this->item->trafficofsx.','.
                                                        (int)$this->item->trafficofsy.'))';
                    }
                    else
                    {
                        $ctrlPositionFullText ="";
                    }
                }
                else
                {
                    $ctrlPositionFullText ="";
                }

                $scripttext .= 'map.addControl(new YMaps.Traffic.Control()'.$ctrlPositionFullText.');' ."\n";
	}


	if (isset($this->item->markermanager) && (int)$this->item->markermanager == 1) 
	{
		$scripttext .= 'var objectManager = new YMaps.ObjectManager();'."\n";
		$scripttext .= 'map.addOverlay(objectManager);'."\n";
	}

	// MarkerGroups
	if (isset($this->item->markergroupcontrol) && (int)$this->item->markergroupcontrol != 0) 
	{
   	   if (isset($this->markergroups) && !empty($this->markergroups)) 
	   {
		if ($compatiblemodersf == 0)
		{
			$imgpath4size = JPATH_ADMINISTRATOR .'/components/com_zhyandexmap/assets/icons/';
		}
		else
		{
			$imgpath4size = JPATH_SITE .'/components/com_zhyandexmap/assets/icons/';
		}
		

		foreach ($this->markergroups as $key => $currentmarkergroup) 
		{
			$imgimg = $imgpathIcons.str_replace("#", "%23", $currentmarkergroup->icontype).'.png';
			$imgimg4size = $imgpath4size.$currentmarkergroup->icontype.'.png';

			list ($imgwidth, $imgheight) = getimagesize($imgimg4size);

			$markergroupname ='';
			$markergroupname = 'markergroup'. $currentmarkergroup->id;
			if ((int)$currentmarkergroup->overridemarkericon != 0) 
			{
				$scripttext .= 'var smg'.$currentmarkergroup->id.' = new YMaps.Style();' ."\n";
				$scripttext .= 'smg'.$currentmarkergroup->id.'.iconStyle = new YMaps.IconStyle();' ."\n";
				$scripttext .= 'smg'.$currentmarkergroup->id.'.iconStyle.href ="'.$imgimg.'";' ."\n";
				$scripttext .= 'smg'.$currentmarkergroup->id.'.iconStyle.size = new YMaps.Point('.$imgwidth.','.$imgheight.');' ."\n";
				$scripttext .= ' YMaps.Styles.add("custom#MarkerGroup'.$currentmarkergroup->id.'", smg'.$currentmarkergroup->id.');'."\n";

				$scripttext .= ' var '.$markergroupname.' = new YMaps.GeoObjectCollection("custom#MarkerGroup'.$currentmarkergroup->id.'");'."\n";
			}
			else
			{
				$scripttext .= ' var '.$markergroupname.' = new YMaps.GeoObjectCollection();'."\n";
			}
			$scripttext .= $markergroupname.'.title = "'.htmlspecialchars(str_replace('\\', '/', $currentmarkergroup->title), ENT_QUOTES, 'UTF-8').'";'."\n";
			if ((int)$this->item->markergroupshowicon == 1)
			{
				$scripttext .= 'addMenuItem('.$markergroupname.', map, YMaps.jQuery("#zhym-menu'.$markergroupcssstyle.'"), "'.$imgimg.'", '.(int)$currentmarkergroup->activeincluster.');'."\n";
			}
			else
			{
				$scripttext .= 'addMenuItem('.$markergroupname.', map, YMaps.jQuery("#zhym-menu'.$markergroupcssstyle.'"), "", '.(int)$currentmarkergroup->activeincluster.');'."\n";
			}    
			if ((int)$currentmarkergroup->activeincluster == 1)
			{
			        $scripttext .= 'map.addOverlay('.$markergroupname.');' ."\n";
			}                                                                                    
		}
	   }
	}

	//UserMarker - begin
	if ($allowUserMarker == 1)
	{
		
		$db = JFactory::getDBO();

		if (isset($_POST['marker_action']) && 
			($_POST['marker_action'] == "insert") ||
			($_POST['marker_action'] == "update") 
			)
		{

			$title = substr($_POST["markername"], 0, 249);
			if ($title == "")
			{
				$title = 'Placemark';
			}

			$markericon = substr($_POST["markerimage"], 0, 100);
			if ($markericon == "")
			{
				$markericon ='default#';
			}
			
			$description = $_POST["markerdescription"];
			$latitude = substr($_POST["markerlat"], 0, 100);
			$longitude = substr($_POST["markerlng"], 0, 100);
			$group = substr($_POST["markergroup"], 0, 100);
			$markercatid = substr($_POST["markercatid"], 0, 100);
			$markerid = (int)substr($_POST["markerid"], 0, 100);
			
			$contactid = substr($_POST["contactid"], 0, 100);
			
			$contactDoInsert = 0;
			
			if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
			{
				$contact_name = substr($_POST["contactname"], 0, 100);
				$contact_position = substr($_POST["contactposition"], 0, 100);
				$contact_phone = substr($_POST["contactphone"], 0, 100);
				$contact_mobile = substr($_POST["contactmobile"], 0, 100);
				$contact_fax = substr($_POST["contactfax"], 0, 100);
				$contact_address = substr($_POST["contactaddress"], 0, 100);
				
				if (($contact_name != "") 
				  ||($contact_position != "")
				  ||($contact_phone != "")
				  ||($contact_mobile != "")
				  ||($contact_fax != "")
				  ||($contact_address != "")
					)
				{
					$contactDoInsert = 1;
				}
			}

			$newRow = new stdClass;
			
			if ($_POST['marker_action'] == "insert")
			{
				$newRow->id = NULL;
				$newRow->userprotection = 0;
				
				if ((isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
				 &&($contactDoInsert == 1))
				{				
					$newRow->showcontact = 2;
				}
				else
				{				
					$newRow->showcontact = 0;
				}
			}
			else
			{
				$newRow->id = $markerid;

				if ((isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
				 &&($contactDoInsert == 1) && ((int)$contactid == 0))
				{				
					$newRow->showcontact = 2;
				}
				
			}
			
			// Data for Contacts - begin
			if ((isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
			  &&($contactDoInsert == 1))
			{
				$newContactRow = new stdClass;
				
				if ($_POST['marker_action'] == "insert")
				{
					$newContactRow->id = NULL;
					$newContactRow->published = (int)$this->item->usercontactpublished;
					$newContactRow->language = '*';
					$newContactRow->access = 1;
				}
				else
				{
					if ((int)$contactid == 0)
					{
						$newContactRow->id = NULL;
						$newContactRow->published = (int)$this->item->usercontactpublished;
						$newContactRow->language = '*';
						$newContactRow->access = 1;
					}
					else
					{
						$newContactRow->id = $contactid;
					}
				}
				
			}			
			// Data for Contacts - end
			
			// because it (quotes) escaped
			$newRow->title = str_replace('\\','', htmlspecialchars($title, ENT_NOQUOTES, 'UTF-8'));
			$newRow->description = str_replace('\\','', htmlspecialchars($description, ENT_NOQUOTES, 'UTF-8'));
			// because it escaped
			$newRow->latitude = htmlspecialchars($latitude, ENT_QUOTES, 'UTF-8');
			$newRow->longitude = htmlspecialchars($longitude, ENT_QUOTES, 'UTF-8');
			$newRow->mapid = $this->item->id;
			$newRow->icontype = htmlspecialchars($markericon, ENT_QUOTES, 'UTF-8');
			$newRow->published = (int)$this->item->usermarkerspublished;
			$newRow->createdbyuser = $currentUser->id;
			$newRow->markergroup = htmlspecialchars($group, ENT_QUOTES, 'UTF-8');
			$newRow->catid = htmlspecialchars($markercatid, ENT_QUOTES, 'UTF-8');

			if ((isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
			  &&($contactDoInsert == 1))
			{
				$newContactRow->name = str_replace('\\','', htmlspecialchars($contact_name, ENT_NOQUOTES, 'UTF-8'));
				if ($newContactRow->name == "")
				{
					$newContactRow->name = $newRow->title;
				}
				$newContactRow->con_position = str_replace('\\','', htmlspecialchars($contact_position, ENT_NOQUOTES, 'UTF-8'));
				$newContactRow->telephone = str_replace('\\','', htmlspecialchars($contact_phone, ENT_NOQUOTES, 'UTF-8'));
				$newContactRow->mobile = str_replace('\\','', htmlspecialchars($contact_mobile, ENT_NOQUOTES, 'UTF-8'));
				$newContactRow->fax = str_replace('\\','', htmlspecialchars($contact_fax, ENT_NOQUOTES, 'UTF-8'));
				$newContactRow->address = str_replace('\\','', htmlspecialchars($contact_address, ENT_NOQUOTES, 'UTF-8'));
			}
			
			if ($_POST['marker_action'] == "insert")
			{
				if ((isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
				  &&($contactDoInsert == 1))
				{
					$dml_contact_result = $db->insertObject( '#__contact_details', $newContactRow, 'id' );
					
					$newRow->contactid = $newContactRow->id;
				}

				$dml_result = $db->insertObject( '#__zhyandexmaps_markers', $newRow, 'id' );
			}
			else
			{
				if ((isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
				  &&($contactDoInsert == 1))
				{
					if (isset($newContactRow->id))
					{
						$dml_contact_result = $db->updateObject( '#__contact_details', $newContactRow, 'id' );
					}
					else
					{
						$dml_contact_result = $db->insertObject( '#__contact_details', $newContactRow, 'id' );
						$newRow->contactid = $newContactRow->id;
					}
				}

				$dml_result = $db->updateObject( '#__zhyandexmaps_markers', $newRow, 'id' );
			}
			
			if ((!$dml_result) || 
			    (isset($this->item->usercontact) && (int)$this->item->usercontact == 1 && ($contactDoInsert == 1) && (!$dml_result))
				)
			{
				//$this->setError($db->getErrorMsg());
				$scripttext .= 'alert("Error (Insert New Marker or Update): " + "' . $db->getEscaped($db->getErrorMsg()).'");';
			}
			else
			{
				$scripttext .= 'window.location = "'.JURI::current().'";'."\n";
				
				$new_id = $newRow->id;

			}
		}
		else if (isset($_POST['marker_action']) && $_POST['marker_action'] == "delete") 
		{

			$contactid = substr($_POST["contactid"], 0, 100);
			$markerid = substr($_POST["markerid"], 0, 100);
		
			if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
			{
			
				if ((int)$contactid != 0)
				{
					$query = $db->getQuery(true);

					$db->setQuery( 'DELETE FROM `#__contact_details` '.
					'WHERE `id`='.(int)$contactid);
					
					if (!$db->query()) {
						//$this->setError($db->getErrorMsg());
						$scripttext .= 'alert("Error (Delete Exist Marker Contact): " + "' . $db->getEscaped($db->getErrorMsg()).'");';
					}
				}
			}


			$query = $db->getQuery(true);

			$db->setQuery( 'DELETE FROM `#__zhyandexmaps_markers` '.
			'WHERE `createdbyuser`='.$currentUser->id.
			' and `id`='.$markerid);

			
			if (!$db->query()) {
				//$this->setError($db->getErrorMsg());
				$scripttext .= 'alert("Error (Delete Exist Marker): " + "' . $db->getEscaped($db->getErrorMsg()).'");';
			}
			else
			{
				$scripttext .= 'window.location = "'.JURI::current().'";'."\n";
			}
		}
		
		$scripttext .= 'if (YMaps.location) {' ."\n";
		$scripttext .= '  var insertPlacemarkLocation = new YMaps.GeoPoint(YMaps.location.longitude, YMaps.location.latitude);' ."\n";
		$scripttext .= '}else {' ."\n";
		$scripttext .= '  var insertPlacemarkLocation = new YMaps.GeoPoint(30.3158, 59.9388);' ."\n";
		$scripttext .= '}' ."\n";

		$scripttext .= 'var insertPlacemark = new YMaps.Placemark(insertPlacemarkLocation, {draggable: true});' ."\n";
		$scripttext .= 'insertPlacemark.name = "'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_NEWMARKER' ).'";' ."\n";
		$scripttext .= 'insertPlacemark.description = "'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_NEWMARKER_DESC' ).'";' ."\n";
		$scripttext .= 'map.addOverlay(insertPlacemark);' ."\n";
		$scripttext .= 'var contentInsertPlacemark = "";'."\n";

		$query = $db->getQuery(true);
		
		$query->select('h.title as text, h.id as value ');
		$query->from('#__zhyandexmaps_markergroups as h');
		$query->leftJoin('#__categories as c ON h.catid=c.id');
		$query->where('1=1');
		// get all groups, because you can add marker and disable group
		//$query->where('h.published=1');
		$query->order('h.title');
		
		$db->setQuery($query);    

		if (!$db->query())
		{
			$scripttext .= 'alert("Error (Load Group List Item): " + "' . $db->getEscaped($db->getErrorMsg()).'");';
		}
		else
		{
			$newMarkerGroupList = $db->loadObjectList();
		}
		

		$functionText  = '';
		$functionText .= 'insertPlacemark.setGeoPoint(current);' ."\n";
		$functionText .= 'contentInsertPlacemark = \'<div id="contentInsertPlacemark">\' +' ."\n";
		$functionText .= '\'<h1 id="headContentInsertPlacemark" class="insertPlacemarkHead">'.
			'<img src="'.$imgpathUtils.'published'.(int)$this->item->usermarkerspublished.'.png" alt="" /> '.
			JText::_( 'COM_ZHYANDEXMAP_MAP_USER_NEWMARKER' ).'</h1>\'+' ."\n";
		$functionText .= '\'<div id="bodyContentInsertPlacemark"  class="insertPlacemarkBody">\'+'."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_LNG' ).' \'+current.getLng() + ' ."\n";
		$functionText .= '    \'<br />'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_LAT' ).' \'+current.getLat() + ' ."\n";
		$functionText .= '    \'<form id="insertPlacemarkForm" action="'.JURI::current().'" method="post">\'+'."\n";

		// Begin Placemark Properties
		$functionText .= '\'<div id="bodyInsertPlacemarkDivA"  class="bodyInsertProperties">\'+'."\n";
		$functionText .= '\'<a id="bodyInsertPlacemarkA" href="javascript:showonlyone(\\\'Placemark\\\',\\\'\\\');" ><img src="'.$imgpathUtils.'collapse.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_PROPERTIES' ).'</a>\'+'."\n";
		$functionText .= '\'</div>\'+'."\n";
		$functionText .= '\'<div id="bodyInsertPlacemark"  class="bodyInsertPlacemarkProperties">\'+'."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_NAME' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<input name="markername" type="text" maxlength="250" size="50" />\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_DESCRIPTION' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<input name="markerdescription" type="text" maxlength="250" size="50" />\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";

		// icon type
		if (isset($this->item->usermarkersicon) && (int)$this->item->usermarkersicon == 1) 
		{
			$iconTypeJS = " onchange=\"javascript: ";
			$iconTypeJS .= " if (document.forms.insertPlacemarkForm.markerimage.options[selectedIndex].value!=\'\') ";
			$iconTypeJS .= " {document.markericonimage.src=\'".$imgpathIcons."\' + document.forms.insertPlacemarkForm.markerimage.options[selectedIndex].value.replace(/#/g,\'%23\') + \'.png\'}";
			$iconTypeJS .= " else ";
			$iconTypeJS .= " {document.markericonimage.src=\'\'}\"";
			
			$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_ICON_TYPE' ).' \'+' ."\n";
			$functionText .= ' \'';
			$functionText .= '<img name="markericonimage" src="'.$imgpathIcons .str_replace("#", "%23", "default#").'png" alt="" />';
			$functionText .= '\'+' ."\n";
			$functionText .= '    \'<br />\'+' ."\n";
			$functionText .= ' \'';
			$functionText .= str_replace('.png<', '<', 
								str_replace('.png"', '"', 
									str_replace('JOPTION_SELECT_IMAGE', JText::_('COM_ZHYANDEXMAP_MAP_USER_IMAGESELECT'),
										str_replace(array("\r", "\r\n", "\n"),'', JHTML::_('list.images',  'markerimage', $active =  "default#", $iconTypeJS, $directoryIcons, $extensions =  "png")))));
			$functionText .= '\'+' ."\n";
			$functionText .= '    \'<br />\'+' ."\n";	

		}
		else
		{
			$functionText .= '    \'<input name="markerimage" type="hidden" value="default#" />\'+' ."\n";	
		}
		$functionText .= '    \'<br />\'+' ."\n";


		
		$functionText .= '\'</div>\'+'."\n";
		// End Placemark Properties

		// Begin Placemark Group Properties
		$functionText .= '\'<div id="bodyInsertPlacemarkGrpDivA"  class="bodyInsertProperties">\'+'."\n";
		$functionText .= '\'<a id="bodyInsertPlacemarkGrpA" href="javascript:showonlyone(\\\'PlacemarkGroup\\\',\\\'\\\');" ><img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_GROUP_PROPERTIES' ).'</a>\'+'."\n";
		$functionText .= '\'</div>\'+'."\n";
		$functionText .= '\'<div id="bodyInsertPlacemarkGrp"  class="bodyInsertPlacemarkGrpProperties">\'+'."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_GROUP' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		
		$functionText .= '    \' <select name="markergroup" > \'+' ."\n";
		$functionText .= '    \' <option value="" selected="selected">'.JText::_( 'COM_ZHYANDEXMAP_MAPMARKER_FILTER_PLACEMARK_GROUP').'</option> \'+' ."\n";
		foreach ($newMarkerGroupList as $key => $newGrp) 
		{
			$functionText .= '    \' <option value="'.$newGrp->value.'">'.$newGrp->text.'</option> \'+' ."\n";
		}
		$functionText .= '    \' </select> \'+' ."\n";
		
		$functionText .= '    \'<br />\'+' ."\n";

		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CATEGORY' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \' <select name="markercatid" > \'+' ."\n";
		$functionText .= '    \' <option value="" selected="selected">'.JText::_( 'COM_ZHYANDEXMAP_MAP_FILTER_CATEGORY').'</option> \'+' ."\n";
		$functionText .= '    \''.str_replace(array("\r", "\r\n", "\n"),'', 
		                       JHtml::_('select.options', JHtml::_('category.options', 'com_zhyandexmap'), 'value', 'text', '')) .
							   '\'+' ."\n";
		$functionText .= '    \' </select> \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '\'</div>\'+'."\n";
		// End Placemark Group Properties
		
		// Begin Contact Properties
if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
{

		$functionText .= '\'<div id="bodyInsertContactDivA"  class="bodyInsertProperties">\'+'."\n";
		$functionText .= '\'<a id="bodyInsertContactA" href="javascript:showonlyone(\\\'Contact\\\',\\\'\\\');" ><img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_PROPERTIES' ).'</a>\'+'."\n";
		$functionText .= '\'</div>\'+'."\n";
		$functionText .= '\'<div id="bodyInsertContact"  class="bodyInsertContactProperties">\'+'."\n";
		$functionText .= '\'<img src="'.$imgpathUtils.'published'.(int)$this->item->usercontactpublished.'.png" alt="" /> \'+'."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_NAME' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<input name="contactname" type="text" maxlength="250" size="50" />\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_POSITION' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<input name="contactposition" type="text" maxlength="250" size="50" />\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_PHONE' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<input name="contactphone" type="text" maxlength="250" size="50" />\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_MOBILE' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<input name="contactmobile" type="text" maxlength="250" size="50" />\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_FAX' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<input name="contactfax" type="text" maxlength="250" size="50" />\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<input name="contactid" type="hidden" value="" />\'+' ."\n";
		$functionText .= '\'</div>\'+'."\n";
		// Contact Address
		$functionText .= '\'<div id="bodyInsertContactAdrDivA"  class="bodyInsertProperties">\'+'."\n";
		$functionText .= '\'<a id="bodyInsertContactAdrA" href="javascript:showonlyone(\\\'ContactAddress\\\',\\\'\\\');" ><img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS_PROPERTIES' ).'</a>\'+'."\n";
		$functionText .= '\'</div>\'+'."\n";
		$functionText .= '\'<div id="bodyInsertContactAdr"  class="bodyInsertContactAdrProperties">\'+'."\n";
		$functionText .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS' ).' \'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<textarea name="contactaddress" cols="35" rows="4"></textarea>\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '    \'<br />\'+' ."\n";
		$functionText .= '\'</div>\'+'."\n";
}
		// End Contact Properties

		$functionText .= '    \'<hr />\'+' ."\n";					
		$functionText .= '    \'<input name="markerlat" type="hidden" value="\'+current.getLat() + \'" />\'+' ."\n";
		$functionText .= '    \'<input name="markerlng" type="hidden" value="\'+current.getLng() + \'" />\'+' ."\n";
		$functionText .= '    \'<input name="marker_action" type="hidden" value="insert" />\'+' ."\n";	
		$functionText .= '    \'<input name="markersubmit" type="submit" value="'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BUTTON_ADD' ).'" />\'+' ."\n";
		$functionText .= '    \'</form>\'+' ."\n";		
		$functionText .= '\'</div>\'+'."\n";
		$functionText .= '\'</div>\';'."\n";

		$functionText .= '    insertPlacemark.setBalloonContent(contentInsertPlacemark);'."\n";

		$scripttext .= 'YMaps.Events.observe(insertPlacemark, insertPlacemark.Events.Drag, function (obj) {' ."\n";
		$scripttext .= '    var current = obj.getGeoPoint().copy();' ."\n";
		
		$scripttext .= $functionText;

		$scripttext .= '});' ."\n";

		$scripttext .= 'YMaps.Events.observe(map, map.Events.Click, function (map, mEvent) {' ."\n";
		$scripttext .= '    var current = mEvent.getGeoPoint().copy();' ."\n";

		$scripttext .= $functionText;
		
		$scripttext .= '});' ."\n";
		
	}
	// New Marker - End
        
	//Balloon	
	if (isset($this->item->balloon)) 
	{
		switch ($this->item->balloon) 
		{
			case 0:
			break;
			case 1:
				$scripttext .= 'map.openBalloon(new YMaps.GeoPoint('.$this->item->longitude.', ' .$this->item->latitude.'), "'.htmlspecialchars(str_replace('\\', '/', $this->item->title), ENT_QUOTES, 'UTF-8').'");' ."\n";
			break;
			case 2:
				$scripttext .= 'var placemark = new YMaps.Placemark(new YMaps.GeoPoint('.$this->item->longitude.', ' .$this->item->latitude.'));' ."\n";
				$scripttext .= 'placemark.name = "' .htmlspecialchars(str_replace('\\', '/', $this->item->title), ENT_QUOTES, 'UTF-8').'";' ."\n";
				$scripttext .= 'placemark.description = "' .htmlspecialchars(str_replace('\\', '/', $this->item->description), ENT_QUOTES, 'UTF-8').'";' ."\n";
				$scripttext .= 'map.addOverlay(placemark);' ."\n";
				$scripttext .= 'placemark.openBalloon();' ."\n";
			break;
			case 3:
				$scripttext .= 'var placemark = new YMaps.Placemark(new YMaps.GeoPoint('.$this->item->longitude.', ' .$this->item->latitude.'));' ."\n";
				$scripttext .= 'placemark.name = "' .htmlspecialchars(str_replace('\\', '/', $this->item->title), ENT_QUOTES, 'UTF-8').'";' ."\n";
				$scripttext .= 'placemark.description = "' .htmlspecialchars(str_replace('\\', '/', $this->item->description), ENT_QUOTES, 'UTF-8').'";' ."\n";
				$scripttext .= 'map.addOverlay(placemark);' ."\n";
				$scripttext .= 'placemark.setIconContent("' .htmlspecialchars(str_replace('\\', '/', $this->item->title), ENT_QUOTES, 'UTF-8').'");' ."\n";
			break;
			default;
				$scripttext .= '' ."\n";
			break;
		}
	}

		
	// Markers
	if (isset($this->markers) && !empty($this->markers)) 
	{
		if ($compatiblemodersf == 0)
		{
			$imgpath4size = JPATH_ADMINISTRATOR .'/components/com_zhyandexmap/assets/icons/';
		}
		else
		{
			$imgpath4size = JPATH_SITE .'/components/com_zhyandexmap/assets/icons/';
		}

		foreach ($this->markers as $key => $currentmarker) 
		{
				// Main IF Begin
				if ( // enabled groups, group is published and marker has it
					(isset($this->item->markergroupcontrol) 
						&& ((int)$this->item->markergroupcontrol != 0)
						&& ($currentmarker->markergroup != 0) 
						&& (((int)$currentmarker->publishedgroup == 1) || ($allowUserMarker == 1))
					) || 
					// enabled groups, group is published and marker without group
					(isset($this->item->markergroupcontrol) 
						&& ((int)$this->item->markergroupcontrol != 0)
						&& ($currentmarker->markergroup == 0) 
						&& (((int)$currentmarker->published == 1) || ($allowUserMarker == 1))
					) ||
					// disables groups and marker is published
					(isset($this->item->markergroupcontrol) 
						&& ((int)$this->item->markergroupcontrol == 0)
						&& (((int)$currentmarker->published == 1) || ($allowUserMarker == 1))
					)
				   )
				{
					$markername ='';
					$markername = 'placemark'. $currentmarker->id;

					if (isset($this->item->markergroupcontrol) && ((int)$this->item->markergroupcontrol != 0)
						&& ((int)$currentmarker->markergroup != 0) && ((int)$currentmarker->overridemarkericon == 1) )
					{
						$scripttext .= 'var '.$markername.'= new YMaps.Placemark(new YMaps.GeoPoint('.$currentmarker->longitude.', ' .$currentmarker->latitude.'));' ."\n";
					}
					else
					{

						if ((int)$currentmarker->overridemarkericon == 0)
						{
							$imgimg = $imgpathIcons.str_replace("#", "%23", $currentmarker->icontype).'.png';
							$imgimg4size = $imgpath4size.$currentmarker->icontype.'.png';

							list ($imgwidth, $imgheight) = getimagesize($imgimg4size);

							$scripttext .= 'var s'. $currentmarker->id.' = new YMaps.Style();' ."\n";
							$scripttext .= 's'. $currentmarker->id.'.iconStyle = new YMaps.IconStyle();' ."\n";
							$scripttext .= 's'. $currentmarker->id.'.iconStyle.href ="'.$imgimg.'";' ."\n";
							$scripttext .= 's'. $currentmarker->id.'.iconStyle.size = new YMaps.Point('.$imgwidth.','.$imgheight.');' ."\n";
							if (isset($currentmarker->iconofsetx) 
							 && isset($currentmarker->iconofsety) 
							 && ((int)$currentmarker->iconofsetx !=0
							  || (int)$currentmarker->iconofsety !=0)
							 )
							{
								$scripttext .= 's'. $currentmarker->id.'.iconStyle.offset = new YMaps.Point('.(int)$currentmarker->iconofsetx.','.(int)$currentmarker->iconofsety.');' ."\n";
							}
						}
						else
						{
							$imgimg = $imgpathIcons.str_replace("#", "%23", $currentmarker->groupicontype).'.png';
							$imgimg4size = $imgpath4size.$currentmarker->groupicontype.'.png';

							list ($imgwidth, $imgheight) = getimagesize($imgimg4size);

							$scripttext .= 'var s'. $currentmarker->id.' = new YMaps.Style();' ."\n";
							$scripttext .= 's'. $currentmarker->id.'.iconStyle = new YMaps.IconStyle();' ."\n";
							$scripttext .= 's'. $currentmarker->id.'.iconStyle.href ="'.$imgimg.'";' ."\n";
							$scripttext .= 's'. $currentmarker->id.'.iconStyle.size = new YMaps.Point('.$imgwidth.','.$imgheight.');' ."\n";
							/* there is no offset in group
							if (isset($currentmarker->iconofsetx) 
							 && isset($currentmarker->iconofsety) 
							 && ((int)$currentmarker->iconofsetx !=0
							  || (int)$currentmarker->iconofsety !=0)
							 )
							{
								$scripttext .= 's'. $currentmarker->id.'.iconStyle.offset = new YMaps.Point('.(int)$currentmarker->iconofsetx.','.(int)$currentmarker->iconofsety.');' ."\n";
							}
							*/
						}
					
						$scripttext .= 'var '.$markername.'= new YMaps.Placemark(new YMaps.GeoPoint('.$currentmarker->longitude.', ' .$currentmarker->latitude.'), {style: s'. $currentmarker->id.' });' ."\n";
					}

					$scripttext .= 'var contentString'. $currentmarker->id.' = \'<div id="content">\' +' ."\n";
					if (isset($currentmarker->markercontent) &&
						(((int)$currentmarker->markercontent == 0) ||
						 ((int)$currentmarker->markercontent == 1))
						)
					{
						$scripttext .= '\'<h1 id="headContent'. $currentmarker->id.'" class="placemarkHead">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->title), ENT_QUOTES, 'UTF-8').'</h1>\'+' ."\n";
					}
					$scripttext .= '\'<div id="bodyContent'. $currentmarker->id.'"  class="placemarkBody">\'+'."\n";

								if ($currentmarker->hrefimage!="")
								{
									 $scripttext .= '\'<img src="'.$currentmarker->hrefimage.'" alt="" />\'+'."\n";
								}

								if (isset($currentmarker->markercontent) &&
									(((int)$currentmarker->markercontent == 0) ||
									 ((int)$currentmarker->markercontent == 2))
									)
								{
									$scripttext .= '\''.htmlspecialchars(str_replace('\\', '/', $currentmarker->description), ENT_QUOTES, 'UTF-8').'\'+'."\n";
								}
								$scripttext .= '\''.str_replace("'", "\'", str_replace(array("\r", "\r\n", "\n"), '', $currentmarker->descriptionhtml)).'\'+'."\n";

								//$scripttext .= ' latlng'. $currentmarker->id. '.toString()+'."\n";

								// Contact info - begin
								if (isset($this->item->usercontact) && ((int)$this->item->usercontact != 0))
								{
									if (isset($currentmarker->showcontact) && ((int)$currentmarker->showcontact != 0))
									{
										switch ((int)$currentmarker->showcontact) 
										{
											case 1:
												if ($currentmarker->contact_name != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_NAME').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_position != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_POSITION').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_position), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_address != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS').' '.str_replace('<br /><br />', '<br />', str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
												}
												if ($currentmarker->contact_phone != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_PHONE').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_mobile != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_MOBILE').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_mobile), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_fax != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_FAX').' '.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_fax), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
											break;
											case 2:
												if ($currentmarker->contact_name != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_position != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_position), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_address != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact"><img src="'.$imgpathUtils.'address.png" alt="'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS').'" />'.str_replace('<br /><br />', '<br />', str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
												}
												if ($currentmarker->contact_phone != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact"><img src="'.$imgpathUtils.'phone.png" alt="'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_PHONE').'" />'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_mobile != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact"><img src="'.$imgpathUtils.'mobile.png" alt="'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_MOBILE').'" />'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_mobile), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_fax != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact"><img src="'.$imgpathUtils.'fax.png" alt="'.JText::_('COM_ZHYANDEXMAP_MAP_USER_CONTACT_FAX').'" />'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_fax), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
											break;
											case 3:
												if ($currentmarker->contact_name != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_position != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_position), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_address != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.str_replace('<br /><br />', '<br />', str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
												}
												if ($currentmarker->contact_phone != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_mobile != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_mobile), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_fax != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_fax), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
											break;
											default;
												if ($currentmarker->contact_name != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_name), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_position != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_position), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_address != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.str_replace('<br /><br />', '<br />', str_replace(array("\r", "\r\n", "\n"), '<br />', htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_address), ENT_QUOTES, 'UTF-8'))).'</p>\'+'."\n";
												}
												if ($currentmarker->contact_phone != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_phone), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_mobile != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_mobile), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
												if ($currentmarker->contact_fax != "") 
												{
													$scripttext .= '\'<p class="placemarkBodyContact">'.htmlspecialchars(str_replace('\\', '/', $currentmarker->contact_fax), ENT_QUOTES, 'UTF-8').'</p>\'+'."\n";
												}
											break;										
										}
									}
								}
								// Contact info - end
								// User info - begin
								if (isset($this->item->useruser) && ((int)$this->item->useruser != 0))
								{
									$scripttext .= get_userinfo_for_marker($currentmarker->createdbyuser, $currentmarker->showuser);
								}
								if ($currentmarker->hrefsite!="")
								{
										$scripttext .= '\'<p><a class="placemarkHREF" href="'.$currentmarker->hrefsite.'" target="_blank">';
										if ($currentmarker->hrefsitename != "")
										{
											$scripttext .= htmlspecialchars($currentmarker->hrefsitename, ENT_QUOTES, 'UTF-8');
										}
										else
										{
											$scripttext .= $currentmarker->hrefsite;
										}
								
										$scripttext .= '</a></p>\'+'."\n";
								}

								
								$scripttext .= '\'</div>\'+'."\n";
					$scripttext .= '\'</div>\';'."\n";

					// Change UserMarker - begin
					if (($allowUserMarker == 1)
					 && (isset($currentmarker->userprotection) && (int)$currentmarker->userprotection == 0))
					{
						$scripttext .= $markername.'.setOptions({draggable: true});' ."\n";
						
						//$scripttext .= 'contentString'.$currentmarker->id.' = contentString'.$currentmarker->id.'+' ."\n";
						// replace content
						$scripttext .= 'contentString'.$currentmarker->id.' = "" +' ."\n";
						$scripttext .= '\'<div id="contentUpdatePlacemark">\'+'."\n";
						//$scripttext .= '    \'<br />\'+' ."\n";
						//$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_LNG' ).' \'+current.getLng() + ' ."\n";
						//$scripttext .= '    \'<br />'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_LAT' ).' \'+current.getLat() + ' ."\n";
						// Form Update
						$scripttext .= '    \'<form id="updatePlacemarkForm'.$currentmarker->id.'" action="'.JURI::current().'" method="post">\'+'."\n";
						$scripttext .= '    \''.'<img src="'.$imgpathUtils.'published'.(int)$currentmarker->published.'.png" alt="" />  \'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
		// Begin Placemark Properties
		$scripttext .= '\'<div id="bodyInsertPlacemarkDivA'.$currentmarker->id.'"  class="bodyInsertProperties">\'+'."\n";
		$scripttext .= '\'<a id="bodyInsertPlacemarkA'.$currentmarker->id.'" href="javascript:showonlyone(\\\'Placemark\\\',\\\''.$currentmarker->id.'\\\');" ><img src="'.$imgpathUtils.'collapse.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_PROPERTIES' ).'</a>\'+'."\n";
		$scripttext .= '\'</div>\'+'."\n";
		$scripttext .= '\'<div id="bodyInsertPlacemark'.$currentmarker->id.'"  class="bodyInsertPlacemarkProperties">\'+'."\n";
						$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_NAME' ).' \'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						$scripttext .= '    \'<input name="markername" type="text" maxlength="250" size="50" value="'. htmlspecialchars($currentmarker->title, ENT_QUOTES, 'UTF-8').'" />\'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						//$scripttext .= '    \'<br />\'+' ."\n";
						$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_DESCRIPTION' ).' \'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						$scripttext .= '    \'<input name="markerdescription" type="text" maxlength="250" size="50" value="'. htmlspecialchars($currentmarker->description, ENT_QUOTES, 'UTF-8').'" />\'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						//$scripttext .= '    \'<br />\'+' ."\n";

						// icon type
						if(isset($this->item->usermarkersicon) && (int)$this->item->usermarkersicon == 1) 
						{
							$iconTypeJS = " onchange=\"javascript: ";
							$iconTypeJS .= " if (document.forms.updatePlacemarkForm".$currentmarker->id.".markerimage.options[selectedIndex].value!=\'\') ";
							$iconTypeJS .= " {document.markericonimage".$currentmarker->id.".src=\'".$imgpathIcons."\' + document.forms.updatePlacemarkForm".$currentmarker->id.".markerimage.options[selectedIndex].value.replace(/#/g,\'%23\') + \'.png\'}";
							$iconTypeJS .= " else ";
							$iconTypeJS .= " {document.markericonimage".$currentmarker->id.".src=\'\'}\"";
							
							$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_ICON_TYPE' ).' \'+' ."\n";
							$scripttext .= ' \'';
							$scripttext .= '<img name="markericonimage'.$currentmarker->id.'" src="'.$imgpathIcons .str_replace("#", "%23", $currentmarker->icontype).'.png" alt="" />';
							$scripttext .= '\'+' ."\n";
							$scripttext .= '    \'<br />\'+' ."\n";
							$scripttext .= ' \'';
							$scripttext .= str_replace('.png<', '<', 
												str_replace('.png"', '"', 
													str_replace('JOPTION_SELECT_IMAGE', JText::_('COM_ZHYANDEXMAP_MAP_USER_IMAGESELECT'),
														str_replace(array("\r", "\r\n", "\n"),'', JHTML::_('list.images',  'markerimage', $active = $currentmarker->icontype.'.png', $iconTypeJS, $directoryIcons, $extensions =  "png")))));
							$scripttext .= '\'+' ."\n";
							$scripttext .= '    \'<br />\'+' ."\n";		
						}
						else
						{
							$scripttext .= '    \'<input name="markerimage" type="hidden" value="default#" />\'+' ."\n";	
						}
						
						$scripttext .= '    \'<br />\'+' ."\n";

		$scripttext .= '\'</div>\'+'."\n";
		// End Placemark Properties
						
		// Begin Placemark Group Properties
		$scripttext .= '\'<div id="bodyInsertPlacemarkGrpDivA'.$currentmarker->id.'"  class="bodyInsertProperties">\'+'."\n";
		$scripttext .= '\'<a id="bodyInsertPlacemarkGrpA'.$currentmarker->id.'" href="javascript:showonlyone(\\\'PlacemarkGroup\\\',\\\''.$currentmarker->id.'\\\');" ><img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_GROUP_PROPERTIES' ).'</a>\'+'."\n";
		$scripttext .= '\'</div>\'+'."\n";
		$scripttext .= '\'<div id="bodyInsertPlacemarkGrp'.$currentmarker->id.'"  class="bodyInsertPlacemarkGrpProperties">\'+'."\n";
						$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_GROUP' ).' \'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						
						$scripttext .= '    \' <select name="markergroup" > \'+' ."\n";
						if ($currentmarker->markergroup == 0)
						{
							$scripttext .= '    \' <option value="" selected="selected">'.JText::_( 'COM_ZHYANDEXMAP_MAPMARKER_FILTER_PLACEMARK_GROUP').'</option> \'+' ."\n";
						}
						else
						{
							$scripttext .= '    \' <option value="">'.JText::_( 'COM_ZHYANDEXMAP_MAPMARKER_FILTER_PLACEMARK_GROUP').'</option> \'+' ."\n";
						}
						foreach ($newMarkerGroupList as $key => $newGrp) 
						{
							if ($currentmarker->markergroup == $newGrp->value)
							{
								$scripttext .= '    \' <option value="'.$newGrp->value.'" selected="selected">'.$newGrp->text.'</option> \'+' ."\n";
							}
							else
							{
								$scripttext .= '    \' <option value="'.$newGrp->value.'">'.$newGrp->text.'</option> \'+' ."\n";
							}
						}
						$scripttext .= '    \' </select> \'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";


		$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CATEGORY' ).' \'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \' <select name="markercatid" > \'+' ."\n";
		$scripttext .= '    \' <option value="" selected="selected">'.JText::_( 'COM_ZHYANDEXMAP_MAP_FILTER_CATEGORY').'</option> \'+' ."\n";
		$scripttext .= '    \''.str_replace(array("\r", "\r\n", "\n"),'', 
		                       JHtml::_('select.options', JHtml::_('category.options', 'com_zhyandexmap'), 'value', 'text', $currentmarker->catid)) .
							   '\'+' ."\n";
		$scripttext .= '    \' </select> \'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";

		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '\'</div>\'+'."\n";
		// End Placemark Group Properties

		// Begin Contact Properties
if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1) 
{

		$scripttext .= '\'<div id="bodyInsertContactDivA'.$currentmarker->id.'"  class="bodyInsertProperties">\'+'."\n";
		$scripttext .= '\'<a id="bodyInsertContactA'.$currentmarker->id.'" href="javascript:showonlyone(\\\'Contact\\\',\\\''.$currentmarker->id.'\\\');" ><img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_PROPERTIES' ).'</a>\'+'."\n";
		$scripttext .= '\'</div>\'+'."\n";
		$scripttext .= '\'<div id="bodyInsertContact'.$currentmarker->id.'"  class="bodyInsertContactProperties">\'+'."\n";
		$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_NAME' ).' \'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \'<input name="contactname" type="text" maxlength="250" size="50" value="'. htmlspecialchars($currentmarker->contact_name, ENT_QUOTES, 'UTF-8').'" />\'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_POSITION' ).' \'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \'<input name="contactposition" type="text" maxlength="250" size="50" value="'. htmlspecialchars($currentmarker->contact_position, ENT_QUOTES, 'UTF-8').'" />\'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_PHONE' ).' \'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \'<input name="contactphone" type="text" maxlength="250" size="50" value="'. htmlspecialchars($currentmarker->contact_phone, ENT_QUOTES, 'UTF-8').'" />\'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_MOBILE' ).' \'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \'<input name="contactmobile" type="text" maxlength="250" size="50" value="'. htmlspecialchars($currentmarker->contact_mobile, ENT_QUOTES, 'UTF-8').'" />\'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_FAX' ).' \'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \'<input name="contactfax" type="text" maxlength="250" size="50" value="'. htmlspecialchars($currentmarker->contact_fax, ENT_QUOTES, 'UTF-8').'" />\'+' ."\n";
		$scripttext .= '\'</div>\'+'."\n";
		// Contact Address
		$scripttext .= '\'<div id="bodyInsertContactAdrDivA'.$currentmarker->id.'"  class="bodyInsertProperties">\'+'."\n";
		$scripttext .= '\'<a id="bodyInsertContactAdrA'.$currentmarker->id.'" href="javascript:showonlyone(\\\'ContactAddress\\\',\\\''.$currentmarker->id.'\\\');" ><img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS_PROPERTIES' ).'</a>\'+'."\n";
		$scripttext .= '\'</div>\'+'."\n";
		$scripttext .= '\'<div id="bodyInsertContactAdr'.$currentmarker->id.'"  class="bodyInsertContactAdrProperties">\'+'."\n";
		$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS' ).' \'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \'<textarea name="contactaddress" cols="35" rows="4" >'. str_replace("\n\n", "'+'\\n'+'", str_replace(array("\r", "\r\n", "\n"), "\n",htmlspecialchars($currentmarker->contact_address, ENT_QUOTES, 'UTF-8'))).'</textarea>\'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '    \'<br />\'+' ."\n";
		$scripttext .= '\'</div>\'+'."\n";
}
		// End Contact Properties
		
						$scripttext .= '    \'<hr />\'+' ."\n";					
						$scripttext .= '    \'<input name="markerlat" type="hidden" value="\'+'.$currentmarker->latitude.' + \'" />\'+' ."\n";
						$scripttext .= '    \'<input name="markerlng" type="hidden" value="\'+'.$currentmarker->longitude.' + \'" />\'+' ."\n";
						$scripttext .= '    \'<input name="marker_action" type="hidden" value="update" />\'+' ."\n";
						$scripttext .= '    \'<input name="markerid" type="hidden" value="'.$currentmarker->id.'" />\'+' ."\n";
						$scripttext .= '    \'<input name="contactid" type="hidden" value="'.$currentmarker->contactid.'" />\'+' ."\n";
						$scripttext .= '    \'<input name="markersubmit" type="submit" value="'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BUTTON_UPDATE' ).'" />\'+' ."\n";
						$scripttext .= '    \'</form>\'+' ."\n";		
						$scripttext .= '\'</div>\'+'."\n";
						// Form Delete
						$scripttext .= '\'<div id="contentDeletePlacemark">\'+'."\n";
						$scripttext .= '    \'<form id="deletePlacemarkForm'.$currentmarker->id.'" action="'.JURI::current().'" method="post">\'+'."\n";
						$scripttext .= '    \'<input name="marker_action" type="hidden" value="delete" />\'+' ."\n";
						$scripttext .= '    \'<input name="markerid" type="hidden" value="'.$currentmarker->id.'" />\'+' ."\n";
						$scripttext .= '    \'<input name="contactid" type="hidden" value="'.$currentmarker->contactid.'" />\'+' ."\n";
						$scripttext .= '    \'<input name="markersubmit" type="submit" value="'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BUTTON_DELETE' ).'" />\'+' ."\n";
						$scripttext .= '    \'</form>\'+' ."\n";		
						$scripttext .= '\'</div>\';'."\n";

						
						
						$scripttext .= 'YMaps.Events.observe('.$markername.', '.$markername.'.Events.Drag, function (obj) {' ."\n";
						$scripttext .= '    var current = obj.getGeoPoint().copy();' ."\n";
						$scripttext .= 'contentUpdateString'.$currentmarker->id.' = "" +' ."\n";
						// Form Update
						$scripttext .= '\'<div id="contentUpdatePlacemark">\'+'."\n";
						$scripttext .= '    \'<form id="updatePlacemarkForm'.$currentmarker->id.'" action="'.JURI::current().'" method="post">\'+'."\n";
						$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_NAME' ).' \'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						$scripttext .= '    \'<input name="markername" type="text" maxlength="250" size="50" value="'. htmlspecialchars($currentmarker->title, ENT_QUOTES, 'UTF-8').'" />\'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_DESCRIPTION' ).' \'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						$scripttext .= '    \'<input name="markerdescription" type="text" maxlength="250" size="50" value="'. htmlspecialchars($currentmarker->description, ENT_QUOTES, 'UTF-8').'" />\'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						$scripttext .= '    \''.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_GROUP' ).' \'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";
						
						$scripttext .= '    \' <select name="markergroup" > \'+' ."\n";
						if ($currentmarker->markergroup == 0)
						{
							$scripttext .= '    \' <option value="" selected="selected"></option> \'+' ."\n";
						}
						else
						{
							$scripttext .= '    \' <option value=""></option> \'+' ."\n";
						}
						foreach ($newMarkerGroupList as $key => $newGrp) 
						{
							if ($currentmarker->markergroup == $newGrp->value)
							{
								$scripttext .= '    \' <option value="'.$newGrp->value.'" selected="selected">'.$newGrp->text.'</option> \'+' ."\n";
							}
							else
							{
								$scripttext .= '    \' <option value="'.$newGrp->value.'">'.$newGrp->text.'</option> \'+' ."\n";
							}
						}
						$scripttext .= '    \' </select> \'+' ."\n";
						$scripttext .= '    \'<br />\'+' ."\n";

						$scripttext .= '    \'<input name="markerlat" type="hidden" value="\'+current.getLat() + \'" />\'+' ."\n";
						$scripttext .= '    \'<input name="markerlng" type="hidden" value="\'+current.getLng() + \'" />\'+' ."\n";
						$scripttext .= '    \'<input name="marker_action" type="hidden" value="update" />\'+' ."\n";
						$scripttext .= '    \'<input name="markerid" type="hidden" value="'.$currentmarker->id.'" />\'+' ."\n";
						$scripttext .= '    \'<input name="markersubmit" type="submit" value="'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BUTTON_UPDATE' ).'" />\'+' ."\n";
						$scripttext .= '    \'</form>\'+' ."\n";		
						$scripttext .= '\'</div>\'+'."\n";
						// Form Delete
						$scripttext .= '\'<div id="contentDeletePlacemark">\'+'."\n";
						$scripttext .= '    \'<form id="deletePlacemarkForm'.$currentmarker->id.'" action="'.JURI::current().'" method="post">\'+'."\n";
						$scripttext .= '    \'<input name="marker_action" type="hidden" value="delete" />\'+' ."\n";
						$scripttext .= '    \'<input name="markerid" type="hidden" value="'.$currentmarker->id.'" />\'+' ."\n";
						$scripttext .= '    \'<input name="markersubmit" type="submit" value="'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BUTTON_DELETE' ).'" />\'+' ."\n";
						$scripttext .= '    \'</form>\'+' ."\n";		
						$scripttext .= '\'</div>\';'."\n";
						$scripttext .= $markername.'.setBalloonContent(contentUpdateString'. $currentmarker->id.');' ."\n";
						$scripttext .= '});' ."\n";

					}
					// Change UserMarker - end
					
					
					$scripttext .= $markername.'.name = "' .htmlspecialchars(str_replace('\\', '/', $currentmarker->title), ENT_QUOTES, 'UTF-8').'";' ."\n";
					$scripttext .= $markername.'.description = "' .htmlspecialchars(str_replace('\\', '/', $currentmarker->description), ENT_QUOTES, 'UTF-8').'";' ."\n";

					$scripttext .= $markername.'.setBalloonContent(contentString'. $currentmarker->id.');' ."\n";
					
					if (isset($currentmarker->showiconcontent) && ((int)$currentmarker->showiconcontent != 0))
					{			
						$scripttext .= $markername.'.setIconContent("'.htmlspecialchars(str_replace('\\', '/', $currentmarker->title), ENT_QUOTES, 'UTF-8').'");' ."\n";
					}
					

					if (isset($this->item->markergroupcontrol) && ((int)$this->item->markergroupcontrol != 0)
						&& ($currentmarker->markergroup != 0))
					{
						$markergroupname ='';
						$markergroupname = 'markergroup'. $currentmarker->markergroup;
						$scripttext .= $markergroupname.'.add('.$markername.');'."\n";

					}
					else
					{
						if (isset($this->item->markermanager) && (int)$this->item->markermanager == 1) 
						{                            
							if (($currentmarker->markergroup != 0) &&
								((int)$currentmarker->markermanagerminzoom != 0) &&
								((int)$currentmarker->markermanagermaxzoom != 0) 
								)
							{
							   $scripttext .= 'objectManager.add('.$markername.','.$currentmarker->markermanagerminzoom.','.$currentmarker->markermanagermaxzoom.');' ."\n";
							}
							else
							{
							   $scripttext .= 'objectManager.add('.$markername.', 1, 17);' ."\n";
							}
						}
						else
						{
							$scripttext .= 'map.addOverlay('.$markername.');' ."\n";
						}
					}

					if ($currentmarker->openbaloon == '1')
					{
						$scripttext .= $markername.'.openBalloon();' ."\n";
					}
					
			}
			// Main IF End
				
		} 
		// End foreach
                
	}


	// Routers
	if (isset($this->routers) && !empty($this->routers)) 
	{
		$routepanelcount = 0;
		$routepaneltotalcount = 0;

		$routeHTMLdescription ='';
		
		//Begin for each Route
		foreach ($this->routers as $key => $currentrouter) 
		{
			$routername ='';
			$routername = 'route'. $currentrouter->id;
			if ($currentrouter->route != "")
			{
				$scripttext .= ' var '.$routername.' = new YMaps.Router(['.$currentrouter->route.'],[],'."\n";
					$scripttext .=       '{ ';
					if (isset($currentrouter->showtype) && (int)$currentrouter->showtype == 1)
					{
						$scripttext .=       ' viewAutoApply: false ';
					}
					else
					{
						$scripttext .=       ' viewAutoApply: true ';
					}
					if (isset($currentrouter->checktraffic) && (int)$currentrouter->checktraffic == 1)
					{
						$scripttext .=       ', avoidTrafficJams: true ';
					}
					else
					{
						$scripttext .=       ', avoidTrafficJams: false ';
					}
					$scripttext .=       '});'."\n";
				$scripttext .=       'map.addOverlay('.$routername.');'."\n";
				$scripttext .=       'YMaps.Events.observe('.$routername.', '.$routername.'.Events.GeocodeError, function (link, number) {'."\n";
				$scripttext .=       '   alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_GEOCODING').'\' + number);'."\n";
				$scripttext .=       '}); '."\n";
				$scripttext .=       'YMaps.Events.observe('.$routername.', '.$routername.'.Events.RouteError, function (number) {'."\n";
				$scripttext .=       '   alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_UNABLE_DRAW_ROUTE').'\' + number);'."\n";
				$scripttext .=       '}); '."\n";

				if (isset($currentrouter->showpanel) && (int)$currentrouter->showpanel == 1) 
				{
					$routepanelcount++;
					if (isset($currentrouter->showpaneltotal) && (int)$currentrouter->showpaneltotal == 1) 
					{
						$routepaneltotalcount++;
					}
				}

				if (isset($currentrouter->showpanel) && (int)$currentrouter->showpanel == 1) 
				{
					$scripttext .= 'YMaps.Events.observe('.$routername.', '.$routername.'.Events.Success, function () {'."\n";
					$scripttext .= ' var total_km = '.$routername.'.getDistance();'."\n";
					$scripttext .= ' var total_time = '.$routername.'.getDuration();'."\n";
					$scripttext .= ' total_km = total_km / 1000.;'."\n";
					$scripttext .= ' total_time = total_time / 60.;'."\n";
					$scripttext .= ' total_km = total_km.toFixed(1);'."\n";
					$scripttext .= ' total_time = total_time.toFixed(1);'."\n";

					$scripttext .= '  document.getElementById("YMapsRoutePanel_Total").innerHTML = "<p>';
					$scripttext .= JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TOTAL_KM');
					$scripttext .= ' " + total_km + " ';
					$scripttext .= JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_KM');
					$scripttext .= ', ';
					$scripttext .= JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TOTAL_TIME');
					if (isset($currentrouter->checktraffic) && (int)$currentrouter->checktraffic == 1)
					{
						$scripttext .= ' '.JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_JAM');
					}					
					$scripttext .= ' " + total_time + " ';
					$scripttext .= JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TIME');
					$scripttext .= '</p>";' ."\n";
					$scripttext .= '}); '."\n";
				}
				
				
			}
			
			
			if ($currentrouter->routebymarker != "")
			{
				$router2name ='';
				$router2name = 'routeByMarker'. $currentrouter->id;
				
				$cs = explode(";", $currentrouter->routebymarker);
				$cs_total = count($cs)-1;
				$cs_idx = 0;
				$wp_list = '';
				$skipRouteCreation = 0;
				foreach($cs as $curroute)
				{	
					$currouteLatLng = parse_route_by_markers($curroute);
					//$scripttext .= 'alert("'.$currouteLatLng.'");'."\n";

					if ($currouteLatLng != "")
					{
						if ($currouteLatLng == "geocode")
						{
							$scripttext .= 'alert(\''.JText::_('COM_ZHYANDEXMAP_MAPROUTER_FINDMARKER_ERROR_GEOCODE').' '.$curroute.'\');'."\n";
							$skipRouteCreation = 1;
						}
						else
						{
							if ($cs_idx == 0)
							{
								$wp_start .= ' '.$currouteLatLng.''."\n";
							}
							else if ($cs_idx == $cs_total)
							{
								$wp_end .= ', '.$currouteLatLng.' '."\n";
							}
							else
							{
								if ($wp_list == '')
								{
									$wp_list .= ', '.$currouteLatLng;
								}
								else
								{
									$wp_list .= ', '.$currouteLatLng;
								}
							}
						}
					}
					else
					{
						$scripttext .= 'alert(\''.JText::_('COM_ZHYANDEXMAP_MAPROUTER_FINDMARKER_ERROR_REASON').' '.$curroute.'\');'."\n";
						$skipRouteCreation = 1;
					}

					$cs_idx += 1;
				}

				if ($skipRouteCreation == 0)
				{
					$routeToDraw = $wp_start . $wp_list . $wp_end;
					
					$scripttext .= ' var '.$router2name.' = new YMaps.Router(['.$routeToDraw.'],[],'."\n";
					$scripttext .=       '{ ';
					if (isset($currentrouter->showtype) && (int)$currentrouter->showtype == 1)
					{
						$scripttext .=       ' viewAutoApply: false ';
					}
					else
					{
						$scripttext .=       ' viewAutoApply: true ';
					}
					if (isset($currentrouter->checktraffic) && (int)$currentrouter->checktraffic == 1)
					{
						$scripttext .=       ', avoidTrafficJams: true ';
					}
					else
					{
						$scripttext .=       ', avoidTrafficJams: false ';
					}
					$scripttext .=       '});'."\n";
					$scripttext .=       'map.addOverlay('.$router2name.');'."\n";
					$scripttext .=       'YMaps.Events.observe('.$router2name.', '.$router2name.'.Events.GeocodeError, function (link, number) {'."\n";
					$scripttext .=       '   alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_GEOCODING').'\' + number);'."\n";
					$scripttext .=       '}); '."\n";
					$scripttext .=       'YMaps.Events.observe('.$router2name.', '.$router2name.'.Events.RouteError, function (number) {'."\n";
					$scripttext .=       '   alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_UNABLE_DRAW_ROUTE').'\' + number);'."\n";
					$scripttext .=       '}); '."\n";

					if (isset($currentrouter->showpanel) && (int)$currentrouter->showpanel == 1) 
					{
						$routepanelcount++;
						if (isset($currentrouter->showpaneltotal) && (int)$currentrouter->showpaneltotal == 1) 
						{
							$routepaneltotalcount++;
						}
					}

					if (isset($currentrouter->showpanel) && (int)$currentrouter->showpanel == 1) 
					{
						$scripttext .= 'YMaps.Events.observe('.$router2name.', '.$router2name.'.Events.Success, function () {'."\n";
						$scripttext .= ' var total_km = '.$router2name.'.getDistance();'."\n";
						$scripttext .= ' var total_time = '.$router2name.'.getDuration();'."\n";
						$scripttext .= ' total_km = total_km / 1000.;'."\n";
						$scripttext .= ' total_time = total_time / 60.;'."\n";
						$scripttext .= ' total_km = total_km.toFixed(1);'."\n";
						$scripttext .= ' total_time = total_time.toFixed(1);'."\n";

						$scripttext .= '  document.getElementById("YMapsRoutePanel_Total").innerHTML = "<p>';
						$scripttext .= JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TOTAL_KM');
						$scripttext .= ' " + total_km + " ';
						$scripttext .= JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_KM');
						$scripttext .= ', ';
						$scripttext .= JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TOTAL_TIME');
						if (isset($currentrouter->checktraffic) && (int)$currentrouter->checktraffic == 1)
						{
							$scripttext .= ' '.JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_JAM');
						}					
						$scripttext .= ' " + total_time + " ';
						$scripttext .= JText::_('COM_ZHYANDEXMAP_MAPROUTER_DETAIL_SHOWPANEL_HDR_TIME');
						$scripttext .= '</p>";' ."\n";
						$scripttext .= '}); '."\n";
					}
				}

			}
			
			
			if (isset($currentrouter->showdescription) && (int)$currentrouter->showdescription == 1) 
			{
				if ($currentrouter->description != "")
				{
					$routeHTMLdescription .= '<h2>';
					$routeHTMLdescription .= htmlspecialchars($currentrouter->description, ENT_QUOTES, 'UTF-8');
					$routeHTMLdescription .= '</h2>';
				}
				if ($currentrouter->descriptionhtml != "")
				{
					$routeHTMLdescription .= str_replace("'", "\'", str_replace(array("\r", "\r\n", "\n"), '', $currentrouter->descriptionhtml));
				}
			}
			
			if ($currentrouter->kmllayerymapsml != "")
			{
				$kml1 = 'YMapsML'.$routername;
				$scripttext .= 'var '.$kml1.' = new YMaps.YMapsML("'.$currentrouter->kmllayerymapsml.'");' ."\n";
				$scripttext .= 'map.addOverlay('.$kml1.');' ."\n";

				$scripttext .= 'YMaps.Events.observe('.$kml1.', '.$kml1.'.Events.Fault, function ('.$kml1.', error) {' ."\n";
				$scripttext .= '    alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_YMAPSML').'\' + error);' ."\n";
				$scripttext .= '});' ."\n";
				
			}

			if ($currentrouter->kmllayerkml != "")
			{
				$kml2 = 'KML'.$routername;
				$scripttext .= 'var '.$kml2.' = new YMaps.KML("'.$currentrouter->kmllayerkml.'");' ."\n";
				$scripttext .= 'map.addOverlay('.$kml2.');' ."\n";
				
				$scripttext .= 'YMaps.Events.observe('.$kml2.', '.$kml2.'.Events.Fault, function ('.$kml2.', error) {' ."\n";
                $scripttext .= '	alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_KML').'\' + error);' ."\n";
				$scripttext .= '});' ."\n";
			}

			if ($currentrouter->kmllayergpx != "")
			{
				$kml3 = 'GPX'.$routername;
				$scripttext .= 'var '.$kml3.' = new YMaps.GPX("'.$currentrouter->kmllayergpx.'");' ."\n";
				$scripttext .= 'map.addOverlay('.$kml3.');' ."\n";

				$scripttext .= 'YMaps.Events.observe('.$kml3.', '.$kml3.'.Events.Fault, function ('.$kml3.', error) {' ."\n";
				$scripttext .= '    alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_GPX').'\' + error);' ."\n";
				$scripttext .= '});' ."\n";
			}
			
		}
		// End for each Route
		
		if ($routepanelcount > 1 || $routepanelcount == 0 || $routepaneltotalcount == 0)
		{
			$scripttext .= 'var toHideRouteDiv = document.getElementById("YMapsRoutePanel_Total");' ."\n";
			$scripttext .= 'toHideRouteDiv.style.display = "none";' ."\n";
			//$scripttext .= 'alert("Hide because > 1 or = 0");';
		}

		if ($routeHTMLdescription != "")
		{
			$scripttext .= '  document.getElementById("YMapsRoutePanel_Description").innerHTML =  "<p>'. $routeHTMLdescription .'</p>";'."\n";
		}
		
		
	}
	// Routes End


	// Paths
	if (isset($this->paths) && !empty($this->paths)) 
	{
		foreach ($this->paths as $key => $currentpath) 
		{
			$scripttext .= ' var spth'.$currentpath->id.' = new YMaps.Style();'."\n";
			$scripttext .= ' spth'.$currentpath->id.'.lineStyle = new YMaps.LineStyle();'."\n";
			$scripttext .= ' spth'.$currentpath->id.'.lineStyle.strokeColor = \''.$currentpath->color.'\';'."\n";
			$scripttext .= ' spth'.$currentpath->id.'.lineStyle.strokeWidth = \''.$currentpath->width.'\';'."\n";
			$scripttext .= ' YMaps.Styles.add("custom#PolyLine'.$currentpath->id.'", spth'.$currentpath->id.');'."\n";

			$scripttext .= ' var pl'.$currentpath->id.' = new YMaps.Polyline([ '."\n";
			$scripttext .=' new YMaps.GeoPoint('.str_replace(";","), new YMaps.GeoPoint(", $currentpath->path).') '."\n";
			$scripttext .= ' ]); '."\n";

			$scripttext .= 'pl'.$currentpath->id.'.setStyle("custom#PolyLine'.$currentpath->id.'");'."\n";
			$scripttext .= 'pl'.$currentpath->id.'.setBalloonContent("'.htmlspecialchars(str_replace('\\', '/', $currentpath->title), ENT_QUOTES, 'UTF-8').'");' ."\n";
			$scripttext .= 'map.addOverlay(pl'.$currentpath->id.');'."\n";

		}
	}

	$context_suffix = 'map';

	if ($this->item->kmllayer != "")
	{
		$kml1 = 'YMapsML'.$context_suffix;
		$scripttext .= 'var '.$kml1.' = new YMaps.YMapsML("'.$this->item->kmllayer.'");' ."\n";
		$scripttext .= 'map.addOverlay('.$kml1.');' ."\n";

		$scripttext .= 'YMaps.Events.observe('.$kml1.', '.$kml1.'.Events.Fault, function ('.$kml1.', error) {' ."\n";
		$scripttext .= '    alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_YMAPSML').'\' + error);' ."\n";
		$scripttext .= '});' ."\n";
		
	}

	if ($this->item->kmllayerkml != "")
	{
		$kml2 = 'KML'.$context_suffix;
		$scripttext .= 'var '.$kml2.' = new YMaps.KML("'.$this->item->kmllayerkml.'");' ."\n";
		$scripttext .= 'map.addOverlay('.$kml2.');' ."\n";
		
		$scripttext .= 'YMaps.Events.observe('.$kml2.', '.$kml2.'.Events.Fault, function ('.$kml2.', error) {' ."\n";
		$scripttext .= '	alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_KML').'\' + error);' ."\n";
		$scripttext .= '});' ."\n";
	}

	if ($this->item->kmllayergpx != "")
	{
		$kml3 = 'GPX'.$context_suffix;
		$scripttext .= 'var '.$kml3.' = new YMaps.GPX("'.$this->item->kmllayergpx.'");' ."\n";
		$scripttext .= 'map.addOverlay('.$kml3.');' ."\n";

		$scripttext .= 'YMaps.Events.observe('.$kml3.', '.$kml3.'.Events.Fault, function ('.$kml3.', error) {' ."\n";
		$scripttext .= '    alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_GPX').'\' + error);' ."\n";
		$scripttext .= '});' ."\n";
	}
	
	
$scripttext .= '});' ."\n";
	


	if (isset($this->item->markergroupcontrol) && (int)$this->item->markergroupcontrol != 0) 
	{
        // Add menu uten in list
        $scripttext .= 'function addMenuItem (group, map, menuContainer, imgname, activeincluster) {    ' ."\n";

        // Show/Hide group
		$scripttext .= 'if (activeincluster == 1) ' ."\n";
		$scripttext .= '{' ."\n";

		$scripttext .= 'YMaps.jQuery("<a class=\"active zhym-menutitle'.$markergroupcssstyle.'\" href=\"#\"><img src=\"" + imgname + "\" alt=\"\" />" + group.title + "</a>") ' ."\n";
        	$scripttext .= '    .bind("click", function () {   ' ."\n";
	        $scripttext .= '        var link = YMaps.jQuery(this);' ."\n";

        	// If menuitem is not active - add group to map,
	        // else - remove
        	$scripttext .= '       if (link.hasClass("active")) { ' ."\n";
	        $scripttext .= '           map.removeOverlay(group);' ."\n";
        	$scripttext .= '       } else {    ' ."\n";
	        $scripttext .= '           map.addOverlay(group);' ."\n";
        	$scripttext .= '       }' ."\n";

	        // change flag on menuitem
        	$scripttext .= '       link.toggleClass("active"); ' ."\n";

	        $scripttext .= '       return false; ' ."\n";
        	$scripttext .= '   })' ."\n";

	        // add new menuitem into list
        	$scripttext .= '   .appendTo(    ' ."\n";
	        $scripttext .= '       YMaps.jQuery("<li></li>").appendTo(menuContainer) ' ."\n";
        	$scripttext .= '   ) ' ."\n";


		$scripttext .= '}' ."\n";
		$scripttext .= 'else' ."\n";
		$scripttext .= '{' ."\n";

		$scripttext .= 'YMaps.jQuery("<a class=\"zhym-menutitle'.$markergroupcssstyle.'\" href=\"#\"><img src=\"" + imgname + "\" alt=\"\" />" + group.title + "</a>") ' ."\n";
        	$scripttext .= '    .bind("click", function () {   ' ."\n";
	        $scripttext .= '        var link = YMaps.jQuery(this);' ."\n";

        	// If menuitem is not active - add group to map,
	        // else - remove
        	$scripttext .= '       if (link.hasClass("active")) { ' ."\n";
	        $scripttext .= '           map.removeOverlay(group);' ."\n";
        	$scripttext .= '       } else {    ' ."\n";
	        $scripttext .= '           map.addOverlay(group);' ."\n";
        	$scripttext .= '       }' ."\n";

	        // change flag on menuitem
        	$scripttext .= '       link.toggleClass("active"); ' ."\n";

	        $scripttext .= '       return false; ' ."\n";
        	$scripttext .= '   })' ."\n";

	        // add new menuitem into list
        	$scripttext .= '   .appendTo(    ' ."\n";
	        $scripttext .= '       YMaps.jQuery("<li></li>").appendTo(menuContainer) ' ."\n";
        	$scripttext .= '   ) ' ."\n";

		$scripttext .= '}' ."\n";


        $scripttext .= '};' ."\n";
	}
// End Marker Group List Control

// Find option Begin
	if (isset($this->item->findcontrol) && (int)$this->item->findcontrol == 1) 
	{
        $scripttext .= 'function showAddressByGeocoding (value) {' ."\n";
        // Delete Previous Result
        $scripttext .= '    map.removeOverlay(geoResult);' ."\n";

        // Geocoding
         $scripttext .= '   var geocoder = new YMaps.Geocoder(value, {results: 1, boundedBy: map.getBounds()});' ."\n";

        // Success geocoding
        $scripttext .= '   YMaps.Events.observe(geocoder, geocoder.Events.Load, function () {' ."\n";
        // if find then add to map
        // set center map
        $scripttext .= '        if (this.length()) ' ."\n";
		$scripttext .= '		{' ."\n";
        $scripttext .= '            geoResult = this.get(0);' ."\n";
        $scripttext .= '            map.addOverlay(geoResult);' ."\n";
        $scripttext .= '            map.setBounds(geoResult.getBounds());' ."\n";
		// add route
		if (isset($this->item->findroute) && (int)$this->item->findroute == 1) 
		{
		
			$scripttext .= '       map.removeOverlay(geoRoute);' ."\n";
			$scripttext .= '       geoRoute = new YMaps.Router([geoResult.getGeoPoint(), mapcenter],[],'."\n";
			$scripttext .= '       { viewAutoApply: true });'."\n";
			$scripttext .= '       map.addOverlay(geoRoute);'."\n";
			
			$scripttext .= '       YMaps.Events.observe(geoRoute, geoRoute.Events.Success, function () {'."\n";
			$scripttext .= '       		geoRoute.getWayPoint(0).setIconContent(\''.JText::_('COM_ZHYANDEXMAP_MAP_FIND_GEOCODING_START_POINT').'\');'."\n";
			
			$scripttext .= '       		geoRoute.getWayPoint(1).setIconContent(\''.JText::_('COM_ZHYANDEXMAP_MAP_FIND_GEOCODING_END_POINT').'\');'."\n";
			$scripttext .= '       		geoRoute.getWayPoint(1).setBalloonContent(\''.JText::_('COM_ZHYANDEXMAP_MAP_FIND_GEOCODING_END_POINT').'\');'."\n";
			$scripttext .= '       });'."\n";	
			
			$scripttext .= '       YMaps.Events.observe(geoRoute, geoRoute.Events.GeocodeError, function (link, number) {'."\n";
			$scripttext .= '         alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_GEOCODING').'\' + number);'."\n";
			$scripttext .= '       }); '."\n";
			
			$scripttext .= '       YMaps.Events.observe(geoRoute, geoRoute.Events.RouteError, function (link, number) {'."\n";
			$scripttext .= '          alert(\''.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_UNABLE_DRAW_ROUTE').'\' + number);'."\n";
			$scripttext .= '       }); '."\n";
		}
		// end add route
        $scripttext .= '        }' ."\n";
		$scripttext .= '		else ' ."\n";
		$scripttext .= '		{' ."\n";
        $scripttext .= '            alert("'.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_FIND_GEOCODING').'");' ."\n";
        $scripttext .= '        }' ."\n";
        $scripttext .= '    });' ."\n";

        // Failure geocoding
        $scripttext .= '    YMaps.Events.observe(geocoder, geocoder.Events.Fault, function (geocoder, error) {' ."\n";
        $scripttext .= '        alert("'.JText::_('COM_ZHYANDEXMAP_MAP_ERROR_FIND_GEOCODING_ERROR').'" + error);' ."\n";
        $scripttext .= '    })' ."\n";
        $scripttext .= '};' ."\n";
	}
// Find option End

// Toggle for Insert Markers
if (isset($this->item->usermarkers) && (int)$this->item->usermarkers == 1) 
{
    if ($allowUserMarker == 1)
    {
			$scripttext .= 'function showonlyone(thename, theid) {'."\n";
			$scripttext .= '  var xPlacemarkA = document.getElementById("bodyInsertPlacemarkA"+theid);'."\n";
			$scripttext .= '  var xPlacemarkGrpA = document.getElementById("bodyInsertPlacemarkGrpA"+theid);'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '  var xContactA = document.getElementById("bodyInsertContactA"+theid);'."\n";
			$scripttext .= '  var xContactAdrA = document.getElementById("bodyInsertContactAdrA"+theid);'."\n";
		}
			$scripttext .= '  if (thename == \'Contact\')'."\n";
			$scripttext .= '  {'."\n";
			$scripttext .= '    var toHide2 = document.getElementById("bodyInsertPlacemark"+theid);'."\n";
			$scripttext .= '    var toHide3 = document.getElementById("bodyInsertPlacemarkGrp"+theid);'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '    var toHide1 = document.getElementById("bodyInsertContactAdr"+theid);'."\n";
			$scripttext .= '    var toShow = document.getElementById("bodyInsertContact"+theid);'."\n";
		}
			$scripttext .= '    xPlacemarkA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_PROPERTIES' ).'\';'."\n";
			$scripttext .= '    xPlacemarkGrpA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_GROUP_PROPERTIES' ).'\';'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '    xContactA.innerHTML = \'<img src="'.$imgpathUtils.'collapse.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_PROPERTIES' ).'\';'."\n";
			$scripttext .= '    xContactAdrA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS_PROPERTIES' ).'\';'."\n";
		}
			$scripttext .= '  }'."\n";
			$scripttext .= '  else if (thename == \'Placemark\')'."\n";
			$scripttext .= '  {'."\n";
			$scripttext .= '    var toHide1 = document.getElementById("bodyInsertPlacemarkGrp"+theid);'."\n";
			$scripttext .= '    var toShow = document.getElementById("bodyInsertPlacemark"+theid);'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '    var toHide2 = document.getElementById("bodyInsertContact"+theid);'."\n";
			$scripttext .= '    var toHide3 = document.getElementById("bodyInsertContactAdr"+theid);'."\n";
		}
			$scripttext .= '    xPlacemarkA.innerHTML = \'<img src="'.$imgpathUtils.'collapse.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_PROPERTIES' ).'\';'."\n";
			$scripttext .= '    xPlacemarkGrpA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_GROUP_PROPERTIES' ).'\';'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '    xContactA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_PROPERTIES' ).'\';'."\n";
			$scripttext .= '    xContactAdrA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS_PROPERTIES' ).'\';'."\n";
		}
			$scripttext .= '  }'."\n";
			$scripttext .= '  else if (thename == \'PlacemarkGroup\')'."\n";
			$scripttext .= '  {'."\n";
			$scripttext .= '    var toShow = document.getElementById("bodyInsertPlacemarkGrp"+theid);'."\n";
			$scripttext .= '    var toHide1 = document.getElementById("bodyInsertPlacemark"+theid);'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '    var toHide2 = document.getElementById("bodyInsertContact"+theid);'."\n";
			$scripttext .= '    var toHide3 = document.getElementById("bodyInsertContactAdr"+theid);'."\n";
		}
			$scripttext .= '    xPlacemarkA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_PROPERTIES' ).'\';'."\n";
			$scripttext .= '    xPlacemarkGrpA.innerHTML = \'<img src="'.$imgpathUtils.'collapse.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_GROUP_PROPERTIES' ).'\';'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '    xContactA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_PROPERTIES' ).'\';'."\n";
			$scripttext .= '    xContactAdrA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS_PROPERTIES' ).'\';'."\n";
		}
			$scripttext .= '  }'."\n";
			$scripttext .= '  else if (thename == \'ContactAddress\')'."\n";
			$scripttext .= '  {'."\n";
			$scripttext .= '    var toHide2 = document.getElementById("bodyInsertPlacemark"+theid);'."\n";
			$scripttext .= '    var toHide3 = document.getElementById("bodyInsertPlacemarkGrp"+theid);'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '    var toHide1 = document.getElementById("bodyInsertContact"+theid);'."\n";
			$scripttext .= '    var toShow = document.getElementById("bodyInsertContactAdr"+theid);'."\n";
		}
			$scripttext .= '    xPlacemarkA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_PROPERTIES' ).'\';'."\n";
			$scripttext .= '    xPlacemarkGrpA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_BASIC_GROUP_PROPERTIES' ).'\';'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '    xContactA.innerHTML = \'<img src="'.$imgpathUtils.'expand.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_PROPERTIES' ).'\';'."\n";
			$scripttext .= '    xContactAdrA.innerHTML = \'<img src="'.$imgpathUtils.'collapse.png">'.JText::_( 'COM_ZHYANDEXMAP_MAP_USER_CONTACT_ADDRESS_PROPERTIES' ).'\';'."\n";
		}
			$scripttext .= '  }'."\n";
			$scripttext .= '  toHide1.style.display = \'none\';'."\n";
			$scripttext .= '  toShow.style.display = \'block\';'."\n";
		if (isset($this->item->usercontact) && (int)$this->item->usercontact == 1)
		{
			$scripttext .= '  toHide2.style.display = \'none\';'."\n";
			$scripttext .= '  toHide3.style.display = \'none\';'."\n";
		}
			$scripttext .= '}'."\n";
    }   
}


$scripttext .= '/*]]>*/</script>' ."\n";
echo '<div style="clear:both;font-size:6px;position:absolute;left:-2000px">Контакты здесь <a href="http://www.seo-kurs.ru/" style="color:#CCCCCC">Омск создание продвижение сайтов</a> <a href="http://www.maximedia.ru/" style="color:#CCCCCC">Новосибирск создание продвижение сайтов</a> - контактная информация</div>';

// Script end

$document->addScript($scriptlink . $loadmodules);

echo $scripttext;



